class BT_SEQUENCE{
    private bseq:LinkedList = new LinkedList();
    private capacity:number = 0;
    constructor(initialCapacity:number) {
        this.INITIALISATION(initialCapacity);
    }
    INITIALISATION(initialCapacity:number) {
        this.bseq = new LinkedList();
        this.capacity = initialCapacity;
    }

    numberOfElements(){
        return this.bseq.size()
    }

    isFull() {
        if (this.bseq.size()===this.capacity) {
            return 1 ;
        }
        else {
            return 0 ;
        }
    }
    get(ii:number) {
        return this.bseq.getAt(ii-1).data ;
    }
    getFirst() {
        return this.bseq.getFirst().data;
    }

    getLast(){
        return this.bseq.getLast().data;
    }

    removeFirst () {
        this.bseq.deleteFirstNode();
    }

    removeLast () {
        this.bseq.deleteLastNode();
    }

    remove(ii:number) {
        this.bseq.deleteAt(ii);
    }

    addFirst (vv:number) {
        this.bseq.insertAtBeginning(vv);
    }

    addLast(vv:number) {
        this.bseq.insertAtEnd(vv) ;
    }

    add(ii:number, vv:number) {
        this.bseq.insertAt(ii-1, vv) ;
    }

    set(ii:number, vv:number){
        this.bseq.set(ii-1, vv);
    }

    clear(){
        this.bseq.clear();
    }

    text(){
        this.bseq.toString();
    }


}


class DataNode {
    public data:number;
    public next:DataNode;
    constructor(data:number, next:DataNode = null){
        this.data = data;
        this.next = next
    }
}

class LinkedList{
    private head:DataNode;
    constructor(){
        this.head = null;
    }

    insertAtBeginning(data:number){
        let newNode = new DataNode(data);
        newNode.next = this.head;
        this.head = newNode;
        return this.head;
    }


    insertAtEnd(data:number){
        let newNode = new DataNode(data);
        if(!this.head){
            this.head = newNode;
            return this.head;
        }
        let tail = this.head;
        while(tail.next !== null){
            tail = tail.next;
        }
        tail.next = newNode;
        return this.head;
    }

    getAt(index:number){
        let counter = 0;
        let node = this.head;
        while (node) {
            if (counter === index) {
                return node;
            }
            counter++;
            node = node.next;
        }
        return null;
    }
    insertAt(data:number, index:number){
        if (!this.head) {
            this.head = new DataNode(data);
            return;
        }
        if (index === 0) {
            this.head = new DataNode(data, this.head);
            return;
        }
        const previous = this.getAt(index - 1);
        let newNode = new DataNode(data);
        newNode.next = previous.next;
        previous.next = newNode;

        return this.head
    }

    deleteFirstNode(){
        if(!this.head){
            return;
        }
        this.head = this.head.next;
        return this.head;
    }

    deleteLastNode(){
        if(!this.head){
            return null;
        }
        if(!this.head.next){
            this.head = null;
            return;
        }
        let previous = this.head;
        let tail = this.head.next;

        while(tail.next !== null){
            previous = tail;
            tail = tail.next;
        }

        previous.next = null;
        return this.head;
    }

    deleteAt(index:number){
        if (!this.head) {
            return;
        }
        if (index === 0) {
            this.head = this.head.next;
            return;
        }
        const previous = this.getAt(index - 1);
        if (!previous || !previous.next) {
            return;
        }
        previous.next = previous.next.next;
        return this.head
    }

    set(index:number, value:number){
        let counter = 0;
        let node = this.head;
        while (node) {
            if (counter === index) {
                node.data = value;
            }
            counter++;
            node = node.next;
        }
        return null;
    }

    clear(){
        this.head = null;
    }

    size(){
        if(!this.head){
            return 0;
        }
        let tail = this.head;
        let count = 0;
        while(tail.next !== null){
            tail = tail.next;
            count++;
        }
        return count;
    }

    getLast(){
        if(!this.head){
            return null;
        }
        if(!this.head.next){
            return this.head;
        }
        let tail = this.head.next;

        while(tail.next !== null){
            tail = tail.next;
        }

        return tail;
    }

    getFirst(){
        return this.head;
    }
}
